#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    unzip -q zip30.zip
    cd zip30
    ed -s unix/Makefile >/dev/null <<EOF
/^CFLAGS_NOOPT =/
s/\$/ -DNO_BZIP2_SUPPORT/
w
q
EOF
    ed -s unix/configure >/dev/null <<EOF
1,\$s/CFLAGS_OPT='-O3'/CFLAGS_OPT="$CFLAGS"/
w
q
EOF
    make -f unix/Makefile generic_gcc IZ_BZIP2=nowhere
    strip -R .note -R .comment zip
    mkdir -p ../zip/bin
    cp zip ../zip/bin/
    cd ..
    rm -rf zip30
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
